t / test-lib.shon commit Merge branch 'jn/maint-gitweb-invalid-regexp' (6a3a3db)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset EMAIL
  47unset LANGUAGE
  48unset $(perl -e '
  49        my @env = keys %ENV;
  50        my $ok = join("|", qw(
  51                TRACE
  52                DEBUG
  53                USE_LOOKUP
  54                TEST
  55                .*_TEST
  56                PROVE
  57                VALGRIND
  58                PERF_AGGREGATING_LATER
  59        ));
  60        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  61        print join("\n", @vars);
  62')
  63GIT_AUTHOR_EMAIL=author@example.com
  64GIT_AUTHOR_NAME='A U Thor'
  65GIT_COMMITTER_EMAIL=committer@example.com
  66GIT_COMMITTER_NAME='C O Mitter'
  67GIT_MERGE_VERBOSITY=5
  68GIT_MERGE_AUTOEDIT=no
  69export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
  70export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  71export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  72export EDITOR
  73
  74# Protect ourselves from common misconfiguration to export
  75# CDPATH into the environment
  76unset CDPATH
  77
  78unset GREP_OPTIONS
  79
  80case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  81        1|2|true)
  82                echo "* warning: Some tests will not work if GIT_TRACE" \
  83                        "is set as to trace on STDERR ! *"
  84                echo "* warning: Please set GIT_TRACE to something" \
  85                        "other than 1, 2 or true ! *"
  86                ;;
  87esac
  88
  89# Convenience
  90#
  91# A regexp to match 5 and 40 hexdigits
  92_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  93_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  94
  95# Zero SHA-1
  96_z40=0000000000000000000000000000000000000000
  97
  98# Line feed
  99LF='
 100'
 101
 102export _x05 _x40 _z40 LF
 103
 104# Each test should start with something like this, after copyright notices:
 105#
 106# test_description='Description of this test...
 107# This test checks if command xyzzy does the right thing...
 108# '
 109# . ./test-lib.sh
 110[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 111                TERM=$ORIGINAL_TERM &&
 112                export TERM &&
 113                [ -t 1 ] &&
 114                tput bold >/dev/null 2>&1 &&
 115                tput setaf 1 >/dev/null 2>&1 &&
 116                tput sgr0 >/dev/null 2>&1
 117        ) &&
 118        color=t
 119
 120while test "$#" -ne 0
 121do
 122        case "$1" in
 123        -d|--d|--de|--deb|--debu|--debug)
 124                debug=t; shift ;;
 125        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 126                immediate=t; shift ;;
 127        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 128                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 129        -h|--h|--he|--hel|--help)
 130                help=t; shift ;;
 131        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 132                verbose=t; shift ;;
 133        -q|--q|--qu|--qui|--quie|--quiet)
 134                # Ignore --quiet under a TAP::Harness. Saying how many tests
 135                # passed without the ok/not ok details is always an error.
 136                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 137        --with-dashes)
 138                with_dashes=t; shift ;;
 139        --no-color)
 140                color=; shift ;;
 141        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 142                valgrind=t; verbose=t; shift ;;
 143        --tee)
 144                shift ;; # was handled already
 145        --root=*)
 146                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 147                shift ;;
 148        *)
 149                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 150        esac
 151done
 152
 153if test -n "$color"; then
 154        say_color () {
 155                (
 156                TERM=$ORIGINAL_TERM
 157                export TERM
 158                case "$1" in
 159                        error) tput bold; tput setaf 1;; # bold red
 160                        skip)  tput bold; tput setaf 2;; # bold green
 161                        pass)  tput setaf 2;;            # green
 162                        info)  tput setaf 3;;            # brown
 163                        *) test -n "$quiet" && return;;
 164                esac
 165                shift
 166                printf "%s" "$*"
 167                tput sgr0
 168                echo
 169                )
 170        }
 171else
 172        say_color() {
 173                test -z "$1" && test -n "$quiet" && return
 174                shift
 175                echo "$*"
 176        }
 177fi
 178
 179error () {
 180        say_color error "error: $*"
 181        GIT_EXIT_OK=t
 182        exit 1
 183}
 184
 185say () {
 186        say_color info "$*"
 187}
 188
 189test "${test_description}" != "" ||
 190error "Test script did not set test_description."
 191
 192if test "$help" = "t"
 193then
 194        echo "$test_description"
 195        exit 0
 196fi
 197
 198exec 5>&1
 199exec 6<&0
 200if test "$verbose" = "t"
 201then
 202        exec 4>&2 3>&1
 203else
 204        exec 4>/dev/null 3>/dev/null
 205fi
 206
 207test_failure=0
 208test_count=0
 209test_fixed=0
 210test_broken=0
 211test_success=0
 212
 213test_external_has_tap=0
 214
 215die () {
 216        code=$?
 217        if test -n "$GIT_EXIT_OK"
 218        then
 219                exit $code
 220        else
 221                echo >&5 "FATAL: Unexpected exit with code $code"
 222                exit 1
 223        fi
 224}
 225
 226GIT_EXIT_OK=
 227trap 'die' EXIT
 228
 229# The user-facing functions are loaded from a separate file so that
 230# test_perf subshells can have them too
 231. "${TEST_DIRECTORY:-.}"/test-lib-functions.sh
 232
 233# You are not expected to call test_ok_ and test_failure_ directly, use
 234# the text_expect_* functions instead.
 235
 236test_ok_ () {
 237        test_success=$(($test_success + 1))
 238        say_color "" "ok $test_count - $@"
 239}
 240
 241test_failure_ () {
 242        test_failure=$(($test_failure + 1))
 243        say_color error "not ok - $test_count $1"
 244        shift
 245        echo "$@" | sed -e 's/^/#       /'
 246        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 247}
 248
 249test_known_broken_ok_ () {
 250        test_fixed=$(($test_fixed+1))
 251        say_color "" "ok $test_count - $@ # TODO known breakage"
 252}
 253
 254test_known_broken_failure_ () {
 255        test_broken=$(($test_broken+1))
 256        say_color skip "not ok $test_count - $@ # TODO known breakage"
 257}
 258
 259test_debug () {
 260        test "$debug" = "" || eval "$1"
 261}
 262
 263test_eval_ () {
 264        # This is a separate function because some tests use
 265        # "return" to end a test_expect_success block early.
 266        eval </dev/null >&3 2>&4 "$*"
 267}
 268
 269test_run_ () {
 270        test_cleanup=:
 271        expecting_failure=$2
 272        test_eval_ "$1"
 273        eval_ret=$?
 274
 275        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 276        then
 277                test_eval_ "$test_cleanup"
 278        fi
 279        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 280                echo ""
 281        fi
 282        return "$eval_ret"
 283}
 284
 285test_skip () {
 286        test_count=$(($test_count+1))
 287        to_skip=
 288        for skp in $GIT_SKIP_TESTS
 289        do
 290                case $this_test.$test_count in
 291                $skp)
 292                        to_skip=t
 293                        break
 294                esac
 295        done
 296        if test -z "$to_skip" && test -n "$test_prereq" &&
 297           ! test_have_prereq "$test_prereq"
 298        then
 299                to_skip=t
 300        fi
 301        case "$to_skip" in
 302        t)
 303                of_prereq=
 304                if test "$missing_prereq" != "$test_prereq"
 305                then
 306                        of_prereq=" of $test_prereq"
 307                fi
 308
 309                say_color skip >&3 "skipping test: $@"
 310                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 311                : true
 312                ;;
 313        *)
 314                false
 315                ;;
 316        esac
 317}
 318
 319# stub; perf-lib overrides it
 320test_at_end_hook_ () {
 321        :
 322}
 323
 324test_done () {
 325        GIT_EXIT_OK=t
 326
 327        if test -z "$HARNESS_ACTIVE"; then
 328                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 329                mkdir -p "$test_results_dir"
 330                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 331
 332                cat >>"$test_results_path" <<-EOF
 333                total $test_count
 334                success $test_success
 335                fixed $test_fixed
 336                broken $test_broken
 337                failed $test_failure
 338
 339                EOF
 340        fi
 341
 342        if test "$test_fixed" != 0
 343        then
 344                say_color pass "# fixed $test_fixed known breakage(s)"
 345        fi
 346        if test "$test_broken" != 0
 347        then
 348                say_color error "# still have $test_broken known breakage(s)"
 349                msg="remaining $(($test_count-$test_broken)) test(s)"
 350        else
 351                msg="$test_count test(s)"
 352        fi
 353        case "$test_failure" in
 354        0)
 355                # Maybe print SKIP message
 356                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 357
 358                if test $test_external_has_tap -eq 0; then
 359                        say_color pass "# passed all $msg"
 360                        say "1..$test_count$skip_all"
 361                fi
 362
 363                test -d "$remove_trash" &&
 364                cd "$(dirname "$remove_trash")" &&
 365                rm -rf "$(basename "$remove_trash")"
 366
 367                test_at_end_hook_
 368
 369                exit 0 ;;
 370
 371        *)
 372                if test $test_external_has_tap -eq 0; then
 373                        say_color error "# failed $test_failure among $msg"
 374                        say "1..$test_count"
 375                fi
 376
 377                exit 1 ;;
 378
 379        esac
 380}
 381
 382# Test the binaries we have just built.  The tests are kept in
 383# t/ subdirectory and are run in 'trash directory' subdirectory.
 384if test -z "$TEST_DIRECTORY"
 385then
 386        # We allow tests to override this, in case they want to run tests
 387        # outside of t/, e.g. for running tests on the test library
 388        # itself.
 389        TEST_DIRECTORY=$(pwd)
 390fi
 391if test -z "$TEST_OUTPUT_DIRECTORY"
 392then
 393        # Similarly, override this to store the test-results subdir
 394        # elsewhere
 395        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
 396fi
 397GIT_BUILD_DIR="$TEST_DIRECTORY"/..
 398
 399if test -n "$valgrind"
 400then
 401        make_symlink () {
 402                test -h "$2" &&
 403                test "$1" = "$(readlink "$2")" || {
 404                        # be super paranoid
 405                        if mkdir "$2".lock
 406                        then
 407                                rm -f "$2" &&
 408                                ln -s "$1" "$2" &&
 409                                rm -r "$2".lock
 410                        else
 411                                while test -d "$2".lock
 412                                do
 413                                        say "Waiting for lock on $2."
 414                                        sleep 1
 415                                done
 416                        fi
 417                }
 418        }
 419
 420        make_valgrind_symlink () {
 421                # handle only executables, unless they are shell libraries that
 422                # need to be in the exec-path.  We will just use "#!" as a
 423                # guess for a shell-script, since we have no idea what the user
 424                # may have configured as the shell path.
 425                test -x "$1" ||
 426                test "#!" = "$(head -c 2 <"$1")" ||
 427                return;
 428
 429                base=$(basename "$1")
 430                symlink_target=$GIT_BUILD_DIR/$base
 431                # do not override scripts
 432                if test -x "$symlink_target" &&
 433                    test ! -d "$symlink_target" &&
 434                    test "#!" != "$(head -c 2 < "$symlink_target")"
 435                then
 436                        symlink_target=../valgrind.sh
 437                fi
 438                case "$base" in
 439                *.sh|*.perl)
 440                        symlink_target=../unprocessed-script
 441                esac
 442                # create the link, or replace it if it is out of date
 443                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 444        }
 445
 446        # override all git executables in TEST_DIRECTORY/..
 447        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 448        mkdir -p "$GIT_VALGRIND"/bin
 449        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 450        do
 451                make_valgrind_symlink $file
 452        done
 453        # special-case the mergetools loadables
 454        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 455        OLDIFS=$IFS
 456        IFS=:
 457        for path in $PATH
 458        do
 459                ls "$path"/git-* 2> /dev/null |
 460                while read file
 461                do
 462                        make_valgrind_symlink "$file"
 463                done
 464        done
 465        IFS=$OLDIFS
 466        PATH=$GIT_VALGRIND/bin:$PATH
 467        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 468        export GIT_VALGRIND
 469elif test -n "$GIT_TEST_INSTALLED" ; then
 470        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 471        error "Cannot run git from $GIT_TEST_INSTALLED."
 472        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 473        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 474else # normal case, use ../bin-wrappers only unless $with_dashes:
 475        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 476        if ! test -x "$git_bin_dir/git" ; then
 477                if test -z "$with_dashes" ; then
 478                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 479                fi
 480                with_dashes=t
 481        fi
 482        PATH="$git_bin_dir:$PATH"
 483        GIT_EXEC_PATH=$GIT_BUILD_DIR
 484        if test -n "$with_dashes" ; then
 485                PATH="$GIT_BUILD_DIR:$PATH"
 486        fi
 487fi
 488GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 489unset GIT_CONFIG
 490GIT_CONFIG_NOSYSTEM=1
 491GIT_ATTR_NOSYSTEM=1
 492export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 493
 494. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
 495
 496if test -z "$GIT_TEST_CMP"
 497then
 498        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 499        then
 500                GIT_TEST_CMP="$DIFF -c"
 501        else
 502                GIT_TEST_CMP="$DIFF -u"
 503        fi
 504fi
 505
 506GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 507export GITPERLLIB
 508test -d "$GIT_BUILD_DIR"/templates/blt || {
 509        error "You haven't built things yet, have you?"
 510}
 511
 512if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 513then
 514        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 515        export GITPYTHONLIB
 516        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 517                error "You haven't built git_remote_helpers yet, have you?"
 518        }
 519fi
 520
 521if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
 522        echo >&2 'You need to build test-chmtime:'
 523        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 524        exit 1
 525fi
 526
 527# Test repository
 528test="trash directory.$(basename "$0" .sh)"
 529test -n "$root" && test="$root/$test"
 530case "$test" in
 531/*) TRASH_DIRECTORY="$test" ;;
 532 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
 533esac
 534test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 535rm -fr "$test" || {
 536        GIT_EXIT_OK=t
 537        echo >&5 "FATAL: Cannot prepare test area"
 538        exit 1
 539}
 540
 541HOME="$TRASH_DIRECTORY"
 542export HOME
 543
 544if test -z "$TEST_NO_CREATE_REPO"; then
 545        test_create_repo "$test"
 546else
 547        mkdir -p "$test"
 548fi
 549# Use -P to resolve symlinks in our working directory so that the cwd
 550# in subprocesses like git equals our $PWD (for pathname comparisons).
 551cd -P "$test" || exit 1
 552
 553this_test=${0##*/}
 554this_test=${this_test%%-*}
 555for skp in $GIT_SKIP_TESTS
 556do
 557        case "$this_test" in
 558        $skp)
 559                say_color skip >&3 "skipping test $this_test altogether"
 560                skip_all="skip all tests in $this_test"
 561                test_done
 562        esac
 563done
 564
 565# Provide an implementation of the 'yes' utility
 566yes () {
 567        if test $# = 0
 568        then
 569                y=y
 570        else
 571                y="$*"
 572        fi
 573
 574        while echo "$y"
 575        do
 576                :
 577        done
 578}
 579
 580# Fix some commands on Windows
 581case $(uname -s) in
 582*MINGW*)
 583        # Windows has its own (incompatible) sort and find
 584        sort () {
 585                /usr/bin/sort "$@"
 586        }
 587        find () {
 588                /usr/bin/find "$@"
 589        }
 590        sum () {
 591                md5sum "$@"
 592        }
 593        # git sees Windows-style pwd
 594        pwd () {
 595                builtin pwd -W
 596        }
 597        # no POSIX permissions
 598        # backslashes in pathspec are converted to '/'
 599        # exec does not inherit the PID
 600        test_set_prereq MINGW
 601        test_set_prereq SED_STRIPS_CR
 602        ;;
 603*CYGWIN*)
 604        test_set_prereq POSIXPERM
 605        test_set_prereq EXECKEEPSPID
 606        test_set_prereq NOT_MINGW
 607        test_set_prereq SED_STRIPS_CR
 608        ;;
 609*)
 610        test_set_prereq POSIXPERM
 611        test_set_prereq BSLASHPSPEC
 612        test_set_prereq EXECKEEPSPID
 613        test_set_prereq NOT_MINGW
 614        ;;
 615esac
 616
 617test -z "$NO_PERL" && test_set_prereq PERL
 618test -z "$NO_PYTHON" && test_set_prereq PYTHON
 619test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 620test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 621
 622# Can we rely on git's output in the C locale?
 623if test -n "$GETTEXT_POISON"
 624then
 625        GIT_GETTEXT_POISON=YesPlease
 626        export GIT_GETTEXT_POISON
 627        test_set_prereq GETTEXT_POISON
 628else
 629        test_set_prereq C_LOCALE_OUTPUT
 630fi
 631
 632# Use this instead of test_cmp to compare files that contain expected and
 633# actual output from git commands that can be translated.  When running
 634# under GETTEXT_POISON this pretends that the command produced expected
 635# results.
 636test_i18ncmp () {
 637        test -n "$GETTEXT_POISON" || test_cmp "$@"
 638}
 639
 640# Use this instead of "grep expected-string actual" to see if the
 641# output from a git command that can be translated either contains an
 642# expected string, or does not contain an unwanted one.  When running
 643# under GETTEXT_POISON this pretends that the command produced expected
 644# results.
 645test_i18ngrep () {
 646        if test -n "$GETTEXT_POISON"
 647        then
 648            : # pretend success
 649        elif test "x!" = "x$1"
 650        then
 651                shift
 652                ! grep "$@"
 653        else
 654                grep "$@"
 655        fi
 656}
 657
 658# test whether the filesystem supports symbolic links
 659ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
 660rm -f y
 661
 662# When the tests are run as root, permission tests will report that
 663# things are writable when they shouldn't be.
 664test -w / || test_set_prereq SANITY